extends ../_docs-template

block vars
  - var activeLink = 'react';
  - var title = 'List React Component | Framework7 React Documentation';

block docs-index

block content


  .docs-nav
    include ../_docs-menu-react
  .docs-content
    .motion-docs-page-title
      h1 List React Component
      script(src="/js/motion/listview.js")
      f7-motion-listview(motion)

    p List views are versatile and powerful user interface components frequently found in apps. A list view presents data in a scrollable list of multiple rows that may be divided into sections/groups.
    p List views have many purposes:
    ul
      li To let users navigate through hierarchically structured data
      li To present an indexed list of items
      li To display detail information and controls in visually distinct groupings
      li To present a selectable list of options
    p List React component represents Framework7's <a href="../docs/list-view.html">List View</a> component.

    h2 List Components
    p There are following components included:
    ul
      li `List`  - main List View element
      li `ListGroup`  - list group element

    h2 List Properties
    table.params-table
      thead
        tr
          th Prop
          th Type
          th Default
          th Description
      tbody
        tr
          th(colspan="4") &lt;List&gt; properties
        tr
          td inset
          td boolean
          td
          td Makes list inset. `insetIos` and `insetMd` props available for theme specific layout
        tr
          td xsmallInset
          td boolean
          td
          td Makes list inset when app width >= 480px. `xsmallInsetIos` and `xsmallInsetMd` props available for theme specific layout
        tr
          td smallInset
          td boolean
          td
          td Makes list inset when app width >= 568px. `smallInsetIos` and `smallInsetMd` props available for theme specific layout
        tr
          td mediumInset
          td boolean
          td
          td Makes list inset when app width >= 768px. `mediumInsetIos` and `mediumInsetMd` props available for theme specific layout
        tr
          td largeInset
          td boolean
          td
          td Makes list inset when app width >= 1024px. `largeInsetIos` and `largeInsetMd` props available for theme specific layout
        tr
          td xlargeInset
          td boolean
          td
          td Makes list inset when app width >= 1200px. `xlargeInsetIos` and `xlargeInsetMd` props available for theme specific layout
        tr
          td strong
          td boolean
          td
          td Adds extra highlighting to the list. `strongIos` and `strongMd` props available for theme specific layout
        tr
          td outline
          td boolean
          td
          td Makes list outline (with border). `outlineIos` and `outlineMd` props available for theme specific layout
        tr
          td dividers
          td boolean
          td
          td Adds dividers (borders) between list items. `dividersIos` and `dividersMd` props available for theme specific layout
        tr
          td mediaList
          td boolean
          td false
          td Enables <a href="../docs/list-view.html#mediaList">Media List</a>
        tr
          td linksList
          td boolean
          td false
          td Enables simplified <a href="../docs/list-view.html#links-list">Links List</a>
        tr
          td simpleList
          td boolean
          td false
          td Enables simplified <a href="../docs/list-view.html#simple-list">Simple List</a>
        tr
          td sortable
          td boolean
          td false
          td Enables <a href="sortable.html">Sortable List</a>
        tr
          td sortableOpposite
          td boolean
          td false
          td Renders sortable handler on opposite side (on left in LTR)
        tr
          td sortableTapHold
          td boolean
          td false
          td Makes list items sortable on item tap and hold (long press). In this case app will rely on custom `taphold` event. To make it work correctly, make sure you have also enabled `touch.tapHold: true` #[a(href="app.html#app-parameters" target="_blank") app parameter]
        tr
          td sortableEnabled
          td boolean
          td false
          td Enables sorting on sortable list
        tr
          td sortableMoveElements
          td boolean
          td
          td When passed it will overwrite same `sortable.moveElements` global app parameter.
        tr
          td menuList
          td boolean
          td
          td Enables <a href="menu-list.html">Menu List</a>
        tr
          td accordion
          td boolean
          td false
          td Enables <a href="accordion.html#accordion-list">Accordion List</a>
        tr
          td accordionOpposite
          td boolean
          td false
          td Renders accordion chevron icon on opposite side (on left in LTR)
        tr
          td contactsList
          td boolean
          td false
          td Enables <a href="contacts-list.html">Contacts List</a> by adding required additional classes for styling
        tr
          td form
          td boolean
          td false
          td Enables `<form>` tag on list block instead of `<div>`
        tr
          td formStoreData
          td boolean
          td false
          td Enables <a href="../docs/form.html#form-storage">form storage</a> for the current form
        tr
          td noChevron
          td boolean
          td false
          td Removes "chevron" icon on nested list item links
        tr
          td chevronCenter
          td boolean
          td false
          td Sets "chevron" icon on nested media list items on center (vertically)
        tr
          td tab
          td boolean
          td false
          td Adds additional "tab" class when block should be used as a Tab
        tr
          td tabActive
          td boolean
          td false
          td Adds additional "tab-active" class when block used as a Tab and makes it active tab
        tr
          td virtualList
          td boolean
          td false
          td Enables Virtual List
        tr
          td virtualListParams
          td object
          td
          td Object with <a href="../docs/virtual-list.html#virtual-list-parameters">Virtual List Parameters</a>
        tr
          th(colspan="4") &lt;ListGroup&gt; properties
        tr
          td mediaList
          td boolean
          td false
          td Enables <a href="../docs/list-view.html#media-list">Media List</a> for this group
        tr
          td sortable
          td boolean
          td false
          td Enables <a href="sortable.html">Sortable List</a> for this group
        tr
          td sortableTapHold
          td boolean
          td false
          td Makes list items sortable on item tap and hold (long press). In this case app will rely on custom `taphold` event. To make it work correctly, make sure you have also enabled `touch.tapHold: true` #[a(href="app.html#app-parameters" target="_blank") app parameter]
        tr
          td simpleList
          td boolean
          td false
          td Enables simplified <a href="../docs/list-view.html#simple-list">Simple List</a> for this group

    h2 List Events
    table.events-table
      thead
        tr
          th Event
          th Description
      tbody
        tr
          th(colspan="2") &lt;List&gt; events
        tr
          td tabShow
          td Event will be triggered when List Block-Tab becomes visible/active
        tr
          td tabHide
          td Event will be triggered when List Block-Tab becomes invisible/inactive
        tr
          td submit
          td Event will be triggered on list-form submit when list used as form (with enabled `form` prop)
        tr
          th(colspan="2") &lt;List&gt; Sortable specific events
        tr
          td sortableEnable
          td Event will be triggered when sortable mode is enabled
        tr
          td sortableDisable
          td Event will be triggered when sortable mode is disabled
        tr
          td sortableSort
          td Event will be triggered after user release currently sorting element in new position. `event.detail` will contain object with `from` and `to` properties with start/new index numbers of sorted list item
        tr
          th(colspan="2") &lt;List&gt; Virtual List specific events
        tr
          td virtualItemBeforeInsert
          td Event will be triggered before item will be added to virtual document fragment
        tr
          td virtualItemsBeforeInsert
          td Event will be triggered after current DOM list will be removed and before new document will be inserted
        tr
          td virtualItemsAfterInsert
          td Event will be triggered after new document fragment with items inserted
        tr
          td virtualBeforeClear
          td Event will be triggered before current DOM list will be removed and replaced with new document fragment
    h2 List Slots
    p List React component (`<List>`) has additional slots for custom elements:
    ul
      li `before-list` - element will be inserted in the beginning of list view and right before `<ul>` main list
      li `after-list` - element will be inserted in the end of list view and right after `<ul>` main list
      li `list` - element will be inserted inside of `<ul>` main list element
    h2 Virtual List
    p For Virtual List usage and examples check the <a href="virtual-list.html">Virtual List React Component</a> documentation.

    h2 Sortable List
    p For Sortable List usage and examples check the <a href="sortable.html">Sortable React Component</a> documentation.

    h2 Accordion List
    p For Accordion List usage and examples check the <a href="accordion.html">Accordion React Component</a> documentation.

    h2 Examples
    +examplePreview('react', 'list.jsx', 'list')
